summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMaxim Kuvyrkov <maxim.kuvyrkov@linaro.org>2020-06-10 15:21:49 +0000
committerMaxim Kuvyrkov <maxim.kuvyrkov@linaro.org>2020-06-19 11:07:29 +0000
commit997622f0717c9dcf36e4b4cf2b514e1650d4134e (patch)
tree6facbabfef59cb256bc6edc32e79e6bd31cc797a
parentbd2d2e766119a08ba5aaf6e2468af39cca86d5c0 (diff)
tcwg_gnu-build.sh: Add *-build_cross and *-check_cross configurations
Change-Id: Ic648660f11602ebf82a34bd95469ba1018592287
-rw-r--r--round-robin.sh37
-rwxr-xr-xtcwg_gnu-build.sh47
2 files changed, 60 insertions, 24 deletions
diff --git a/round-robin.sh b/round-robin.sh
index 1a8ede27..25256ec5 100644
--- a/round-robin.sh
+++ b/round-robin.sh
@@ -330,25 +330,28 @@ build_abe ()
action="$action --check $project"
fi
- # Use our custom sources for everything, but kernel headers.
local custom_abe_src_opt=""
local git_dir="$project"
- if [ x"$component" != x"linux" ]; then
- git_dir="$git_dir.git"
- custom_abe_src_opt="$project=http://git.l.o/$git_dir~master --disable update"
-
- if ! $check; then
- clone_repo $project
-
- # Don't use ABE's repo clone functions and setup abe/snapshots/
- # directory to have the right entries.
- local git_path
- git_path="abe/snapshots/$git_dir"
- rm -rf $git_path $git_path~master
- ln -s "$(pwd)/$project" $git_path
- ln -s "$(pwd)/$project" $git_path~master
- fi
- fi
+ case "$component" in
+ # Use our custom sources for everything, but kernel headers and dejagnu.
+ linux|dejagnu) ;;
+ *)
+ git_dir="$git_dir.git"
+ custom_abe_src_opt="$project=http://git.l.o/$git_dir~master --disable update"
+
+ if ! $check; then
+ clone_repo $project
+
+ # Don't use ABE's repo clone functions and setup abe/snapshots/
+ # directory to have the right entries.
+ local git_path
+ git_path="abe/snapshots/$git_dir"
+ rm -rf $git_path $git_path~master
+ ln -s "$(pwd)/$project" $git_path
+ ln -s "$(pwd)/$project" $git_path~master
+ fi
+ ;;
+ esac
cd abe
diff --git a/tcwg_gnu-build.sh b/tcwg_gnu-build.sh
index 28fd2f78..2ab102fc 100755
--- a/tcwg_gnu-build.sh
+++ b/tcwg_gnu-build.sh
@@ -32,14 +32,24 @@ rr[top_artifacts]=$(abs_path "${rr[top_artifacts]}")
IFS=- read -a ci_config <<EOF
${rr[ci_config]}
EOF
-rr[target]="native"
# type_of_test contains the type of action to perform in this test
# campaign: bootstrap, bootstrap_lto, check_binutils, ....
type_of_test=${type_of_test-${ci_config[3]}}
case "$type_of_test" in
- check_binutils) rr[components]="binutils" ;;
- *) rr[components]="gcc" ;;
+ *_binutils)
+ rr[target]="${rr[target]-native}"
+ rr[components]="binutils"
+ ;;
+ *bootstrap*)
+ rr[target]="${rr[target]-native}"
+ rr[components]="gcc"
+ ;;
+ *_cross)
+ rr[target]="${rr[target]-${ci_config[2]}}"
+ rr[components]="binutils gcc glibc qemu"
+ ;;
+ *) assert_with_msg "Unknown type_of_test: $type_of_test" false
esac
# Use baseline branches by default.
@@ -67,9 +77,13 @@ case "${rr[mode]}" in
default_finish_at="update_baseline"
;;
"bisect")
- case "$(print_single_updated_component)" in
- binutils|gcc) default_start_at="build_abe-${type_of_test#check_}" ;;
- *) assert false ;;
+ case "$(print_single_updated_component):$type_of_test" in
+ binutils:*) default_start_at="build_abe-binutils" ;;
+ gcc:*_cross) default_start_at="build_abe-stage1" ;;
+ gcc:*) default_start_at="build_abe-${type_of_test#check_}" ;;
+ glibc:*) default_start_at="build_abe-glibc" ;;
+ qemu:*) default_start_at="build_abe-qemu" ;;
+ *) assert_with_msg "Trying to bisecting unknown component: $(print_single_updated_component)" false ;;
esac
default_finish_at="check_regression"
;;
@@ -124,9 +138,28 @@ no_regression_p ()
)
}
-run_step stop_on_fail -1 reset_artifacts
+run_step stop_on_fail -10 reset_artifacts
run_step stop_on_fail x prepare_abe
case "$type_of_test" in
+ build_cross)
+ run_step skip_on_fail 0 true
+ run_step skip_on_fail 1 build_abe binutils
+ run_step skip_on_fail 2 build_abe stage1
+ run_step skip_on_fail 3 build_abe linux
+ run_step skip_on_fail 4 build_abe glibc
+ run_step skip_on_fail 5 build_abe stage2
+ run_step skip_on_fail 6 build_abe qemu
+ ;;
+ check_cross)
+ run_step skip_on_fail -8 build_abe binutils
+ run_step skip_on_fail -7 build_abe stage1
+ run_step skip_on_fail -6 build_abe glibc
+ run_step skip_on_fail -5 build_abe linux
+ run_step skip_on_fail -4 build_abe stage2
+ run_step skip_on_fail -3 build_abe qemu
+ run_step skip_on_fail 0 build_abe dejagnu
+ run_step skip_on_fail 1 build_abe check_gcc
+ ;;
check_*)
run_step skip_on_fail 0 build_abe ${type_of_test#check_}
run_step skip_on_fail 1 build_abe ${type_of_test}